//+------------------------------------------------------------------+
//|                                           MACDSimpleReshetov.mq4 |
//|                               Copyright  2006, Yury V. Reshetov |
//|                                         http://reshetov.xnet.uz/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Yury V. Reshetov ICQ: 282715499"
#property link      "http://reshetov.xnet.uz/"
//----   . 
//Lots -   
extern double Lots = 2;
//  ()    
//    
extern int  DF = 1;
//  ()    
//     
extern int  DS = 2;
//   
extern int  SignalPeriod = 10;
// prevtime -   ( )
static int prevtime = 0;
//+------------------------------------------------------------------+
//|                                              |
//+------------------------------------------------------------------+
int init()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//|                                         |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//|  start                                                    |
//+------------------------------------------------------------------+
int start()
  {
   //  
   int ticket = 0;
   // ,    ? 
   //   ,  .
   //         
   if(Time[0] == prevtime) 
       return(0);
   //   
   prevtime = Time[0];
   //    MACD
   double main = iMACD(Symbol(), 0, SignalPeriod + DF, SignalPeriod + DS + DF, 
                       SignalPeriod, PRICE_CLOSE, MODE_MAIN, 0);
   //    MACD
   double signal = iMACD(Symbol(), 0, SignalPeriod + DF, SignalPeriod + DS + DF, 
                         SignalPeriod, PRICE_CLOSE, MODE_SIGNAL, 0); 
   //  
   int total = OrdersTotal();
   for(int cnt = 0; cnt < total; cnt++) 
     {
       // - 
       OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
       int tick = OrderTicket();
       double openprice = OrderOpenPrice();
       double closeprice = Bid;
       double comission = OrderCommission();
       double swap = OrderSwap();
       double profit = OrderProfit();
       // ,    ?
       if(OrderSymbol() == Symbol()) 
         { // !  
           //   ,    
           if(OrderType() == OP_BUY && main < 0) 
             {
              //    ,   
              if(OrderClose(OrderTicket(), OrderLots(), closeprice, 3, Blue)) 
                {
                 //   
                 SendMail("Close buy position " + Symbol(), "Order #" + 
                    tick + ", close at price " + closeprice + " with profit $" + 
                    profit + ".\nOpen price " + openprice + "\nComission " + 
                    comission + "\nSwap " + swap + ".\n___\nBalance $" + 
                    AccountBalance() + "\nEquity $" + AccountEquity() + "\nTotalProfit $" + 
                    AccountProfit() + "\nFreeMargin $" + AccountFreeMargin());
                }
              return(0);
             }  
           //   ,    
           if(OrderType() == OP_SELL && main > 0) 
             {
              closeprice = Ask;
              //     ,    
              if(OrderClose(OrderTicket(), OrderLots(), closeprice, 3, Red)) 
                {
                 //   
                 SendMail("Close Sell position " + Symbol(), "Order #" + 
                 tick + ", close at price " + closeprice + " with profit $" + 
                 profit + ".\nOpen price " + openprice + "\nComission " + 
                 comission + "\nSwap " + swap + ".\n___\nBalance $" + 
                 AccountBalance() + "\nEquity $" + AccountEquity() + "\nTotalProfit $" + 
                 AccountProfit() + "\nFreeMargin $" + AccountFreeMargin());
                }
              return(0);
             }
           //       ,    , 
           //     
           return(0);
         }
     }
   //       ,    
   if((main * signal) > 0) 
     {
       //    
       if(main > 0) 
         {
           //  
           if(main > signal)
               ticket = OrderSend(Symbol(), OP_BUY, Lots, Ask, 3, 0, 0, "MACDSimple", 
                                  888, 0, Blue);
           return(0); 
         } 
       else 
         {
           //   
           if (main < signal)
              ticket = OrderSend(Symbol(), OP_SELL, Lots, Bid, 3, 0, 0, "MACDSimple", 
                                 888, 0, Red);
           return(0); 
         }
     }
   return(0);
  }
//+------------------------------------------------------------------+

